#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif

precision highp float;

#ifdef EXTERNAL_OSE
uniform samplerExternalOES sTexture;
#else
uniform sampler2D sTexture;
#endif

uniform vec2 singleStepOffset;
uniform highp vec4 params;
uniform vec2 ScreenVec;
uniform int ispng;
uniform float bright;
uniform int filterType;
varying highp vec2 vTextureCoord;

const highp vec3 W = vec3(0.299, 0.587, 0.114);
const mat3 saturateMatrix = mat3(
1.1102, -0.0598, -0.061,
-0.0774, 1.0826, -0.1186,
-0.0228, -0.0228, 1.1772);
float hardlight(float color)
{
    if (color <= 0.5)
    {
        color = color * color * 2.0;
    }
    else
    {
        color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
    }
    return color;
}
// const float offset = 1.0 / 300.0;
void main(){
    vec2 blurCoordinates[24];
    int filterTypeSub = filterType;
    vec2 s;
    s = vTextureCoord;
    if (filterTypeSub == 0) {
        //none
    }
    if (filterTypeSub == 1) {
        //上下
        if (vTextureCoord.x > 0.5){
            s.x = 1.0 - vTextureCoord.x;
        }
    }
    if (filterTypeSub == 2) {
        //左右
        if (vTextureCoord.y > 0.5){
            s.y = 1.0 - vTextureCoord.y;
        }
    }
    blurCoordinates[0] = s.xy + singleStepOffset * vec2(0.0, -10.0);
    blurCoordinates[1] = s.xy + singleStepOffset * vec2(0.0, 10.0);
    blurCoordinates[2] = s.xy + singleStepOffset * vec2(-10.0, 0.0);
    blurCoordinates[3] = s.xy + singleStepOffset * vec2(10.0, 0.0);
    blurCoordinates[4] = s.xy + singleStepOffset * vec2(5.0, -8.0);
    blurCoordinates[5] = s.xy + singleStepOffset * vec2(5.0, 8.0);
    blurCoordinates[6] = s.xy + singleStepOffset * vec2(-5.0, 8.0);
    blurCoordinates[7] = s.xy + singleStepOffset * vec2(-5.0, -8.0);
    blurCoordinates[8] = s.xy + singleStepOffset * vec2(8.0, -5.0);
    blurCoordinates[9] = s.xy + singleStepOffset * vec2(8.0, 5.0);
    blurCoordinates[10] = s.xy + singleStepOffset * vec2(-8.0, 5.0);
    blurCoordinates[11] = s.xy + singleStepOffset * vec2(-8.0, -5.0);
    blurCoordinates[12] = s.xy + singleStepOffset * vec2(0.0, -6.0);
    blurCoordinates[13] = s.xy + singleStepOffset * vec2(0.0, 6.0);
    blurCoordinates[14] = s.xy + singleStepOffset * vec2(6.0, 0.0);
    blurCoordinates[15] = s.xy + singleStepOffset * vec2(-6.0, 0.0);
    blurCoordinates[16] = s.xy + singleStepOffset * vec2(-4.0, -4.0);
    blurCoordinates[17] = s.xy + singleStepOffset * vec2(-4.0, 4.0);
    blurCoordinates[18] = s.xy + singleStepOffset * vec2(4.0, -4.0);
    blurCoordinates[19] = s.xy + singleStepOffset * vec2(4.0, 4.0);
    blurCoordinates[20] = s.xy + singleStepOffset * vec2(-2.0, -2.0);
    blurCoordinates[21] = s.xy + singleStepOffset * vec2(-2.0, 2.0);
    blurCoordinates[22] = s.xy + singleStepOffset * vec2(2.0, -2.0);
    blurCoordinates[23] = s.xy + singleStepOffset * vec2(2.0, 2.0);
    float sampleColor = texture2D(sTexture, s).g * 22.0;
    sampleColor += texture2D(sTexture, blurCoordinates[0]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[1]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[2]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[3]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[4]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[5]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[6]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[7]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[8]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[9]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[10]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[11]).g;
    sampleColor += texture2D(sTexture, blurCoordinates[12]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[13]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[14]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[15]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[16]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[17]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[18]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[19]).g * 2.0;
    sampleColor += texture2D(sTexture, blurCoordinates[20]).g * 3.0;
    sampleColor += texture2D(sTexture, blurCoordinates[21]).g * 3.0;
    sampleColor += texture2D(sTexture, blurCoordinates[22]).g * 3.0;
    sampleColor += texture2D(sTexture, blurCoordinates[23]).g * 3.0;
    //对绿⾊色通道进⾏行行⾼高斯模糊保留留得到模糊后的值
    sampleColor = sampleColor / 62.0;
    //⾼高反差保留留
    vec3 centralColor = texture2D(sTexture, s).rgb;
    float highpass = centralColor.g - sampleColor + 0.5;
    for (int i = 0; i < 5;i++)
    {
        highpass = hardlight(highpass);
    }
    float lumance = dot(centralColor, W);
    float alpha = pow(lumance, params.r);
    vec3 smoothColor = centralColor + (centralColor-vec3(highpass))*alpha*0.1;
    smoothColor.r = clamp(pow(smoothColor.r, params.g), 0.0, 1.0);
    smoothColor.g = clamp(pow(smoothColor.g, params.g), 0.0, 1.0);
    smoothColor.b = clamp(pow(smoothColor.b, params.g), 0.0, 1.0);
    vec3 lvse = vec3(1.0)-(vec3(1.0)-smoothColor)*(vec3(1.0)-centralColor);
    vec3 bianliang = max(smoothColor, centralColor);
    vec3 rouguang = 2.0*centralColor*smoothColor + centralColor*centralColor -
    2.0*centralColor*centralColor*smoothColor;
    gl_FragColor = vec4(mix(centralColor, lvse, alpha), 1.0);
    gl_FragColor.rgb = mix(gl_FragColor.rgb, bianliang, alpha);
    gl_FragColor.rgb = mix(gl_FragColor.rgb, rouguang, params.b);
    gl_FragColor.r = log(1.0 + 0.2 * gl_FragColor.r)/log(1.2);
    gl_FragColor.g = log(1.0 + 0.2 * gl_FragColor.g)/log(1.2);
    gl_FragColor.b = log(1.0 + 0.2 * gl_FragColor.b)/log(1.2);
    if (ispng == 1) {
        vec3 satcolor = gl_FragColor.rgb * saturateMatrix;
        gl_FragColor.rgb = mix(gl_FragColor.rgb, satcolor, params.a);
        gl_FragColor = vec4((gl_FragColor.rgb + vec3(bright)), gl_FragColor.w);
    } else if (ispng == 2){
        gl_FragColor = texture2D(sTexture, s);
    } else
    {
        gl_FragColor = texture2D(sTexture, s);
    }
}