uniform mat4 uMVPMatrix;
uniform int right_to_left;
attribute vec3 aPosition;
attribute vec2 aTexCoor;

const int GAUSSIAN_SAMPLES = 9;
uniform vec2 singleStepOffset;

varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main()
{
    gl_Position = uMVPMatrix * vec4(aPosition, 1);
    if (right_to_left == 1)
    {
        textureCoordinate = vec2(aTexCoor.x, 1.0 - aTexCoor.y);
    }
    else
    {
        textureCoordinate = aTexCoor;
    }

    if (right_to_left == 1)
    {
        textureCoordinate = vec2(aTexCoor.x, 1.0 - aTexCoor.y);
    }
    else
    {
        textureCoordinate = aTexCoor;
    }

    int multiplier = 0;
    vec2 blurStep;

    for (int i = 0; i < GAUSSIAN_SAMPLES; i++)
    {
        multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2));

        blurStep = float(multiplier) * singleStepOffset;
        blurCoordinates[i] = aTexCoor + blurStep;
        if (right_to_left == 1) {
            blurCoordinates[i] = vec2(blurCoordinates[i].x, 1. - blurCoordinates[i].y);
        }
    }
}