#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif
precision mediump float;
varying vec2 vTextureCoord;


uniform samplerExternalOES inputImageTexture;

uniform highp float aspectRatio;
uniform highp vec2 center;
uniform highp float radius;
uniform highp float scale;

void main()
{
    highp vec2 textureCoordinateToUse = vec2(vTextureCoord.x, (vTextureCoord.y * aspectRatio + 0.5 - 0.5 * aspectRatio));
    highp float dist = distance(center, textureCoordinateToUse);
    textureCoordinateToUse = vTextureCoord;

    if (dist < radius)
    {
        textureCoordinateToUse -= center;
        highp float percent = 1.0 - ((radius - dist) / radius) * scale;
        percent = percent * percent;

        textureCoordinateToUse = textureCoordinateToUse * percent;
        textureCoordinateToUse += center;
    }

    gl_FragColor =texture2D(inputImageTexture, textureCoordinateToUse);
}
