#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif
precision mediump float;
#ifdef EXTERNAL_OSE
uniform samplerExternalOES sTexture;
#else
uniform sampler2D sTexture;
#endif
varying vec2 vTextureCoord;

uniform lowp mat4 colorMatrix;
uniform lowp float intensity;


void main()
{
    lowp vec4 textureColor = texture2D(sTexture, vTextureCoord);
    lowp vec4 outputColor = textureColor * colorMatrix;

    gl_FragColor =(intensity * outputColor) + ((1.0 - intensity) * textureColor);
}