#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif

precision lowp float;

#ifdef EXTERNAL_OSE
uniform samplerExternalOES sTexture;
#else
uniform sampler2D sTexture;
#endif
uniform sampler2D inputImageTexture2;//blowout;
uniform sampler2D inputImageTexture3;//overlay;
uniform sampler2D inputImageTexture4;//map
varying vec2 vTextureCoord;//接收从顶点着色器过来的参数




void main()
{

    vec4 texel = texture2D(sTexture, vTextureCoord);
    vec3 bbTexel = texture2D(inputImageTexture2, vTextureCoord).rgb;

    texel.r = texture2D(inputImageTexture3, vec2(bbTexel.r, texel.r)).r;
    texel.g = texture2D(inputImageTexture3, vec2(bbTexel.g, texel.g)).g;
    texel.b = texture2D(inputImageTexture3, vec2(bbTexel.b, texel.b)).b;

    vec4 mapped;
    mapped.r = texture2D(inputImageTexture4, vec2(texel.r, .16666)).r;
    mapped.g = texture2D(inputImageTexture4, vec2(texel.g, .5)).g;
    mapped.b = texture2D(inputImageTexture4, vec2(texel.b, .83333)).b;
    mapped.a = 1.0;

    gl_FragColor =mapped;
}