#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif
precision mediump float;
varying vec2 vTextureCoord;

uniform samplerExternalOES inputImageTexture;
uniform lowp float saturation;


// Values from \Graphics Shaders: Theory and Practice\ by Bailey and Cunningham
const mediump vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);

void main()
{
    lowp vec4 textureColor = texture2D(inputImageTexture, vTextureCoord);
    lowp float luminance = dot(textureColor.rgb, luminanceWeighting);
    lowp vec3 greyScaleColor = vec3(luminance);

    gl_FragColor =vec4(mix(greyScaleColor, textureColor.rgb, saturation), textureColor.a);

}