uniform mat4 uMVPMatrix;
uniform int right_to_left;
attribute vec3 aPosition;
attribute vec2 aTexCoor;

uniform float imageWidthFactor;
uniform float imageHeightFactor;
uniform float sharpness;

varying  vec2 textureCoordinate;
varying  vec2 leftTextureCoordinate;
varying  vec2 rightTextureCoordinate;
varying  vec2 topTextureCoordinate;
varying  vec2 bottomTextureCoordinate;

varying  float centerMultiplier;
varying  float edgeMultiplier;

void main()
{
    gl_Position = uMVPMatrix * vec4(aPosition, 1.);

    mediump vec2 widthStep = vec2(imageWidthFactor, 0.0);
    mediump vec2 heightStep = vec2(0.0, imageHeightFactor);

    textureCoordinate = aTexCoor;
    leftTextureCoordinate = aTexCoor - widthStep;
    rightTextureCoordinate = aTexCoor + widthStep;
    topTextureCoordinate = aTexCoor + heightStep;
    bottomTextureCoordinate = aTexCoor- heightStep;

    if (right_to_left == 1)
    {
        textureCoordinate = vec2(textureCoordinate.x, 1.0 - textureCoordinate.y);
        leftTextureCoordinate = vec2(leftTextureCoordinate.x, 1.0 - leftTextureCoordinate.y);
        rightTextureCoordinate = vec2(rightTextureCoordinate.x, 1.0 - rightTextureCoordinate.y);
        topTextureCoordinate = vec2(topTextureCoordinate.x, 1.0 - topTextureCoordinate.y);
        bottomTextureCoordinate = vec2(bottomTextureCoordinate.x, 1.0 - bottomTextureCoordinate.y);
    }

    centerMultiplier = 1.0 + 4.0 * sharpness;
    edgeMultiplier = sharpness;
}
