#ifdef EXTERNAL_OSE
#extension GL_OES_EGL_image_external : require
#endif

precision mediump float;
uniform samplerExternalOES inputImageTexture;
varying vec2 vTextureCoord;

uniform lowp vec2 vignetteCenter;
uniform lowp vec3 vignetteColor;
uniform highp float vignetteStart;
uniform highp float vignetteEnd;


void main()
{
    lowp vec3 rgb = texture2D(inputImageTexture, vTextureCoord).rgb;
    lowp float d = distance(vTextureCoord, vec2(vignetteCenter.x, vignetteCenter.y));
    lowp float percent = smoothstep(vignetteStart, vignetteEnd, d);
    gl_FragColor =vec4(mix(rgb.r, vignetteColor.r, percent), mix(rgb.g, vignetteColor.g, percent), mix(rgb.b, vignetteColor.b, percent), 1.0);
}
